require 'sketchup.rb'

class RS_material_recorder
  
  def material_recorder
    model=Sketchup.active_model
    materials = model.materials
    model.set_attribute "RSmr_add_new","RS_no_material", 0
    #辞書登録
    adic = model.attribute_dictionaries
    rsmr_lists=[]
    #RSモノだけピックアップ
    adic.each { | key |
      if key.name[0..3]=="RSmr"
        rsmr_lists << key.name
      end #if
    }
    prompts = ["登録するマテリアルセット名(新規は「RSmr_add_new」を選択)"]
    values = ["RSmr_add_new"]
    com = [rsmr_lists.join("|")]
    results = inputbox prompts, values, com,"RSmaterialrecorder"
    return if not results
    @rsm_name=results[0]
    if  @rsm_name=="RSmr_add_new"
      @rsm_name="RSmr_" + UI.inputbox(["新しいマテリアルセット名"],[""],"RSmaterialrecorder")[0]
    end #if
    for m in materials
      if m.name[0..1]=="RS"
        m_tmp = m.name.to_s + "|"
        m_tmp = m_tmp + m.texture.filename.to_s + "|" if m.texture
        m_tmp = m_tmp + (m.texture.width*25.4).to_s + "|" if m.texture
        m_tmp = m_tmp + (m.texture.height*25.4).to_s + "|" if m.texture
        m_tmp = m_tmp + "|||" if not m.texture
        m_tmp = m_tmp + m.color.to_s + "|"
        m_tmp = m_tmp + m.alpha.to_s# + "\n"
        value = model.set_attribute @rsm_name,m.name, m_tmp
      end #if
    end #for
  end #def
  
  def material_reminder
    model=Sketchup.active_model
    #辞書登録
    adic = model.attribute_dictionaries
    rsmr_lists=[]
    #RSモノだけピックアップ
    adic.each { | key |
      if key.name[0..3]=="RSmr" && key.name !="RSmr_add_new"
        rsmr_lists << key.name
      end #if
    }
    prompts = ["呼び出すマテリアルセット名"]
    values = [@rsmr_name]
    com = [rsmr_lists.join("|")]
    results = inputbox prompts, values, com,"RSmaterialreminder"
    return if not results
    
    adic_rsmr = adic[results[0]]
    materials = Sketchup.active_model.materials
    adic_rsmr.each_key{|mr|
        mt=[]
        if adic_rsmr[mr]
          mt = adic_rsmr[mr].to_s.split("|")
          m_name = mt[0]
          m_texture = mt[1]
          m_width = mt[2]
          m_height = mt[3]
          r=mt[4][6..-2].split(",")[0].to_i
          g=mt[4][6..-2].split(",")[1].to_i
          b=mt[4][6..-2].split(",")[2].to_i
          m_alpha = mt[5].to_f
          set_material(m_name ,m_texture ,m_width ,m_height ,r,g,b,m_alpha)
        end #if
      }
  end #def
  
  def record_canceler
    model=Sketchup.active_model
    #辞書登録
    adic = model.attribute_dictionaries
    rsmr_lists=[]
    #RSモノだけピックアップ
    adic.each { | key |
      if key.name[0..3]=="RSmr" && key.name !="RSmr_add_new"
        rsmr_lists << key.name
      end #if
    }
    prompts = ["削除するマテリアルセット名"]
    values = [@rsmr_name]
    com = [rsmr_lists.join("|")]
    results = inputbox prompts, values, com,"RSmaterialcancelser"
    return if not results
    
    adic_rsmr = adic[results[0]]
    result = UI.messagebox results[0]+"を削除しますか?", MB_YESNO
    if result == 6 # Yes
      adic.delete results[0]
    end

  end #def
  
  def set_material(m_name ,m_texture ,m_width ,m_height ,r,g,b,alpha)
    materials = Sketchup.active_model.materials
    check = false
    for mt in materials
      check = true if m_name == mt.name
    end #for
    if check == false
      material = materials.add material_name
    end #if
      materials[m_name].texture = m_texture
    if m_texture != ""
      materials[m_name].texture.size = [m_width.to_i.mm,m_height.to_i.mm]
    else
      materials[m_name].texture = ""
   end #if
      materials[m_name].color=Sketchup::Color.new [ r , g , b ]
      materials[m_name].alpha = alpha
  end #def
  
  #/////////////  SU本体設定  ///////////
  
  
  unless ( file_loaded?("RSmaterialrecorder.rb"))
    #ツールバー追加
    plugins = Sketchup.find_support_file("Plugins")
#    imgdir = File.join(plugins, "rsico")
    imgdir = File.dirname(__FILE__) + "/rsico/"
    tb = UI::Toolbar.new("RSmaterialrecorder")
    
    cmd = UI::Command.new("material_recorder") { RS_material_recorder.new.material_recorder }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "RSmrecorder.png")
    cmd.status_bar_text = cmd.tooltip = "material_recorder"
    tb.add_item cmd
    
    cmd = UI::Command.new("material_reminder") { RS_material_recorder.new.material_reminder }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "RSmreminder.png")
    cmd.status_bar_text = cmd.tooltip = "material_reminder"
    tb.add_item cmd
    
    cmd = UI::Command.new("record_canceler") { RS_material_recorder.new.record_canceler }
    cmd.large_icon =  cmd.small_icon = File.join(imgdir, "RSmcancel.png")
    cmd.status_bar_text = cmd.tooltip = "record_canceler"
    tb.add_item cmd
    
    tb.show if tb.get_last_state == -1
  end
  
  file_loaded("RSmaterialrecorder.rb")
end #of class
